From Wikipedia, the free encyclopedia

Jump to: navigation, search

For the programming paradigm, see Dynamic programming language.

This article may require cleanup to meet Wikipedia's quality standards. Please improve this article if you can. The talk page may contain suggestions. (January 2010) |

In mathematics and computer science, dynamic programming is a method for solving complex problems by breaking them down into simpler steps. It is applicable to problems exhibiting the properties of overlapping subproblems which are on

Top-down dynamic programming simply means storing the results of certain calculations, which are later used again since the completed calculation is a sub-problem of a larger calculation. Bottom-up dynamic programming involves formulating a complex calculation as a recursive series of simpler calculations.

[edit] History

The term dynamic programming was originally used in the 1940s by Richard Bellman to describe the process of solving problems where on

The word dynamic was chosen by Bellman because it sounded impressive, not because it described how the method worked.[3] The word programming referred to the use of the method to find an optimal program, in the sense of a military schedule for training or logistics. This usage is the same as that in the phrases linear programming and mathematical programming, a synonym for optimization.[4]

[edit] Overview

Figure 1. Finding the shortest path in a graph using optimal substructure; a straight line indicates a single edge; a wavy line indicates a shortest path between the two vertices it connects (other nodes on these paths are not shown); the bold line is the overall shortest path from start to goal.

Dynamic programming is both a mathematical optimization method and a computer programming method. In both contexts it refers to simplifying a complicated problem by breaking it down into simpler subproblems in a recursive manner. While some decision problems cannot be taken apart this way, decisions that span several points in time do often break apart recursively; Bellman called this the "Principle of Optimality". Likewise, in computer science, a problem which can be broken down recursively is said to have optimal substructure.

If subproblems can be nested recursively inside larger problems, so that dynamic programming methods are applicable, then there is a relation between the value of the larger problem and the values of the subproblems.[5] In the optimization literature this relationship is called the Bellman equation.

[edit] Dynamic programming in mathematical optimization

In terms of mathematical optimization, dynamic programming usually refers to a simplification of a decision by breaking it down into a sequence of decision steps over time. This is done by defining a sequence of value functions V1 , V2 , ... Vn , with an argument y representing the state of the system at times i from 1 to n. The definition of Vn(y) is the value obtained in state y at the last time n. The values Vi at earlier times i=n-1,n-2,...,2,1 can be found by working backwards, using a recursive relationship called the Bellman equation. For i=2,...n, Vi -1 at any state y is calculated from Vi by maximizing a simple function (usually the sum) of the gain from decision i-1 and the function Vi at the new state of the system if this decision is made. Since Vi has already been calculated for the needed states, the above operation yields Vi -1 for those states. Finally, V1 at the initial state of the system is the value of the optimal solution. The optimal values of the decision variables can be recovered, on

[edit] Dynamic programming in computer programming

There are two key attributes that a problem must have in order for dynamic programming to be applicable: optimal substructure and overlapping subproblems which are on

Optimal substructure means that the solution to a given optimization problem can be obtained by the combination of optimal solutions to its subproblems. Consequently, the first step towards devising a dynamic programming solution is to check whether the problem exhibits such optimal substructure. Such optimal substructures are usually described by means of recursion. For example, given a graph G=(V,E), the shortest path p from a vertex u to a vertex v exhibits optimal substructure: take any intermediate vertex w on this shortest path p. If p is truly the shortest path, then the path p1 from u to w and p2 from w to v are indeed the shortest paths between the corresponding vertices (by the simple cut-and-paste argument described in CLRS). Hence, on

Overlapping subproblems means that the space of subproblems must be small, that is, any recursive algorithm solving the problem should solve the same subproblems over and over, rather than generating new subproblems. For example, consider the recursive formulation for generating the Fibonacci series: Fi = Fi-1 + Fi-2, with base case F1=F2=1. Then F43 = F42 + F41, and F42 = F41 + F40. Now F41 is being solved in the recursive subtrees of both F43 as well as F42. Even though the total number of subproblems is actually small (on

Figure 2. The subproblem graph for the Fibonacci sequence. The fact that it is not a tree indicates overlapping subproblems.

This can be achieved in either of two ways:[citation needed]

Top-down approach: This is the direct fall-out of the recursive formulation of any problem. If the solution to any problem can be formulated recursively using the solution to its subproblems, and if its subproblems are overlapping, then on

Bottom-up approach: This is the more interesting case. On

Some programming languages can automatically memoize the result of a function call with a particular set of arguments, in order to speed up call-by-name evaluation (this mechanism is referred to as call-by-need). Some languages make it possible portably (e.g. Scheme, Common Lisp or Perl), some need special extensions (e.g. C++, see [6]). Some languages have automatic memoization built in such as tabled Prolog. In any case, this is on

[edit] Example: mathematical optimization

[edit] Optimal consumption and saving

A mathematical optimization problem that is often used in teaching dynamic programming to economists (because it can be solved by hand[7]) concerns a consumer who lives over the periods t = 0,1,2,...,T and must decide how much to consume and how much to save in each period.

Let ct be consumption in period t, and assume consumption yields utility u(ct) = ln(ct) as long as the consumer lives. Assume the consumer is impatient, so that he discounts future utility by a factor b each period, where 0 < b < 1. Let kt be capital in period t. Assume initial capital is a given amount k0 > 0, and suppose that this period's capital and consumption determine next period's capital as , where A is a positive constant and 0 < a < 1. Assume capital cannot be negative. Then the consumer's decision problem can be written as follows:

- subject to for all t = 0,1,2,...,T

Written this way, the problem looks complicated, because it involves solving for all the choice variables c0,c1,c2,...,cT and k1,k2,k3,...,kT + 1 simultaneously. (Note that k0 is not a choice variable—the consumer's initial capital is taken as given.)

The dynamic programming approach to solving this problem involves breaking it apart into a sequence of smaller decisions. To do so, we define a sequence of value functions Vt(k), for t = 0,1,2,...,T,T + 1 which represent the value of having any amount of capital k at each time t. Note that VT + 1(k) = 0, that is, there is (by assumption) no utility from having capital after death.

The value of any quantity of capital at any previous time can be calculated by backward induction using the Bellman equation. In this problem, for each t = 0,1,2,...,T, the Bellman equation is

- subject to

This problem is much simpler than the on

To actually solve this problem, we work backwards. For simplicity, the current level of capital is denoted as k. VT + 1(k) is already known, so using the Bellman equation on

Working backwards, it can be shown that the value function at time t = T ? j is

where each vT ? j is a constant, and the optimal amount to consume at time t = T ? j is

which can be simplified to

- , and , and , etc.

We see that it is optimal to consume a larger fraction of current wealth as on

[edit] Examples: Computer algorithms

[edit] Dijkstra's algorithm for the shortest path problem

From a dynamic programming point of view, Dijkstra's algorithm for the shortest path problem is a successive approximation scheme that solves the dynamic programming functional equation for the shortest path problem by the Reaching method.[8][9] [10]

In fact, Dijkstra's explanation of the logic behind the algorithm,[11] namely

Problem 2. Find the path of minimum total length between two given nodes P and Q.

We use the fact that, if R is a node on the minimal path from P to Q, knowledge of the latter implies the knowledge of the minimal path from P to R.

is a paraphrasing of Bellman's famous Principle of Optimality in the context of the shortest path problem.

[edit] Fibonacci sequence

Here is a naive implementation of a function finding the nth member of the Fibonacci sequence, based directly on the mathematical definition:

function fib(n) if n = 0 return 0 if n = 1 return 1 return fib(n ? 1) + fib(n ? 2)

Notice that if we call, say,

fib(5)

, we produce a call tree that calls the function on the same value many different times:

fib(5)

fib(4) + fib(3)

(fib(3) + fib(2)) + (fib(2) + fib(1))

((fib(2) + fib(1)) + (fib(1) + fib(0))) + ((fib(1) + fib(0)) + fib(1))

(((fib(1) + fib(0)) + fib(1)) + (fib(1) + fib(0))) + ((fib(1) + fib(0)) + fib(1))

In particular,

fib(2)

was calculated three times from scratch. In larger examples, many more values of

fib

, or subproblems, are recalculated, leading to an exponential time algorithm.

Now, suppose we have a simple map object, m, which maps each value of

fib

that has already been calculated to its result, and we modify our function to use it and update it. The resulting function requires on

var m := map(0 → 0, 1 → 1) function fib(n) if map m does not contain key n m[n] := fib(n ? 1) + fib(n ? 2) return m[n]

This technique of saving values that have already been calculated is called memoization; this is the top-down approach, since we first break the problem into subproblems and then calculate and store values.

In the bottom-up approach we calculate the smaller values of

fib

first, then build larger values from them. This method also uses O(n) time since it contains a loop that repeats n ? 1 times, however it on

function fib(n) var previousFib := 0, currentFib := 1 if n = 0 return 0 else if n = 1 return 1 repeat n ? 1 times var newFib := previousFib + currentFib previousFib := currentFib currentFib := newFib return currentFib

In both these examples, we on

fib(2)

on

fib(4)

and

fib(3)

, instead of computing it every time either of them is evaluated. (Note the calculation of the Fibonacci sequence is used to demonstrate dynamic programming. An O(1) formula exists from which an arbitrary term can be calculated, which is more efficient than any dynamic programming technique.)

[edit] A type of balanced 0-1 matrix

Consider the problem of assigning values, either zero or on`n` × `n` matrix, `n` even, so that each row and each column contains exactly `n` / 2 zeros and `n` / 2 on`n` = 4, three possible solutions are

We ask how many different assignments there are for a given n. There are at least three possible approaches: brute force, backtracking, and dynamic programming. Brute force consists of checking all assignments of zeros and on

We consider `k` × `n` boards, where 1 ≤ `k` ≤ `n`, whose k rows contain n / 2 zeros and n / 2 on`k` × `n` board and recursively compute the number of solutions to the remaining (`k` - 1) × `n` board, adding the numbers of solutions for every admissible assignment of the top row and returning the sum, which is being memoized. The base case is the trivial subproblem, which occurs for a 1 × `n` board. The number of solutions for this board is either zero or on`n` / 2 (0,1) and `n` / 2 (1,0) pairs or not.

For example, in the two boards shown above the sequences of vectors would be

((2, 2) (2, 2) (2, 2) (2, 2)) ((2, 2) (2, 2) (2, 2) (2, 2)) k = 4 0 1 0 1 0 0 1 1 ((1, 2) (2, 1) (1, 2) (2, 1)) ((1, 2) (1, 2) (2, 1) (2, 1)) k = 3 1 0 1 0 0 0 1 1 ((1, 1) (1, 1) (1, 1) (1, 1)) ((0, 2) (0, 2) (2, 0) (2, 0)) k = 2 0 1 0 1 1 1 0 0 ((0, 1) (1, 0) (0, 1) (1, 0)) ((0, 1) (0, 1) (1, 0) (1, 0)) k = 1 1 0 1 0 1 1 0 0 ((0, 0) (0, 0) (0, 0) (0, 0)) ((0, 0) (0, 0), (0, 0) (0, 0))

The number of solutions (sequence A058527 in OEIS) is

Links to the Perl source of the backtracking approach, as well as a MAPLE and a C implementation of the dynamic programming approach may be found among the external links.

[edit] Checkerboard

Consider a checkerboard with n × n squares and a cost-function c(i, j) which returns a cost associated with square i,j (i being the row, j being the column). For instance (on a 5 × 5 checkerboard),

5 | 6 | 7 | 4 | 7 | 8 |
---|---|---|---|---|---|

4 | 7 | 6 | 1 | 1 | 4 |

3 | 3 | 5 | 7 | 8 | 2 |

2 | - | 6 | 7 | 0 | - |

1 | - | - | *5* | - | - |

1 | 2 | 3 | 4 | 5 |

Thus c(1, 3) = 5

Let us say you had a checker that could start at any square on the first rank (i.e., row) and you wanted to know the shortest path (sum of the costs of the visited squares are at a minimum) to get to the last rank, assuming the checker could move on

5 | |||||
---|---|---|---|---|---|

4 | |||||

3 | |||||

2 | x | x | x | ||

1 | o | ||||

1 | 2 | 3 | 4 | 5 |

This problem exhibits optimal substructure. That is, the solution to the entire problem relies on solutions to subproblems. Let us define a function q(i, j) as

- q(i, j) = the minimum cost to reach square (i, j)

If we can find the values of this function for all the squares at rank n, we pick the minimum and follow that path backwards to get the shortest path.

Note that q(i, j) is equal to the minimum cost to get to any of the three squares below it (since those are the on

5 | |||||
---|---|---|---|---|---|

4 | A | ||||

3 | B | C | D | ||

2 | |||||

1 | |||||

1 | 2 | 3 | 4 | 5 |

q(A) = min(q(B),q(C),q(D)) + c(A)

Now, let us define q(i, j) in somewhat more general terms:

n \\ c(i, j) & i = n \\ \min(q(i-1, j-1), q(i-1, j), q(i-1, j+1)) + c(i,j) & \mbox{otherwise.}\end{cases}" src="http://upload.wikimedia.org/math/0/f/b/0fb0f025049401ca3431105aadbf7e2f.png"<

The first line of this equation is there to make the recursive property simpler (when dealing with the edges, so we need on

c(i, j)

is the cost-function, and

min()

returns the minimum of a number of values:

function minCost(i, j) if j < 1 or j > n return infinity else if i = n return c(i, j) else return min( minCost(i+1, j-1), minCost(i+1, j), minCost(i+1, j+1) ) + c(i, j)

It should be noted that this function on

q[i, j]

rather than using a function. This avoids recomputation; before computing the cost of a path, we check the array

q[i, j]

to see if the path cost is already there.

We also need to know what the actual shortest path is. To do this, we use another array

p[i, j]

, a predecessor array. This array implicitly stores the path to any square s by storing the previous node on the shortest path to s, i.e. the predecessor. To reconstruct the path, we lookup the predecessor of s, then the predecessor of that square, then the predecessor of that square, and so on, until we reach the starting square. Consider the following co

function computeShortestPathArrays() for x from 1 to n q[1, x] := c(1, x) for y from 1 to n q[y, 0] := infinity q[y, n + 1] := infinity for y from 2 to n for x from 1 to n m := min(q[y-1, x-1], q[y-1, x], q[y-1, x+1]) q[y, x] := m + c(y, x) if m = q[y-1, x-1] p[y, x] := -1 else if m = q[y-1, x] p[y, x] := 0 else p[y, x] := 1

Now the rest is a simple matter of finding the minimum and printing it.

function computeShortestPath() computeShortestPathArrays() minIndex := 1 min := q[n, 1] for i from 2 to n if q[n, i] < min minIndex := i min := q[n, i] printPath(n, minIndex)

function printPath(y, x) print(x) print("<-") if y = 2 print(x + p[y, x]) else printPath(y-1, x + p[y, x])

[edit] Sequence alignment

In genetics, sequence alignment is an imp

The problem can be stated naturally as a recursion, a sequence A is optimally edited into a sequence B by either:

inserting the first character of B, and performing an optimal alignment of A and the tail of B

deleting the first character of A, and performing the optimal alignment of the tail of A and B

replacing the first character of A with the first character of B, and performing optimal alignments of the tails of A and B.

The partial alignments can be tabulated in a matrix, where cell (i,j) contains the cost of the optimal alignment of A[1..i] to B[1..j]. The cost in cell (i,j) can be calculated by adding the cost of the relevant operations to the cost of its neighboring cells, and selecting the optimum.

Different variants exist, see Smith-Waterman and Needleman-Wunsch.

[edit] Tower of Hanoi Puzzle

A model set of the Towers of Hanoi (with 8 disks)

An animated solution of the Tower of Hanoi puzzle for T(4,3).

The Tower of Hanoi or Towers of Hanoi is a mathematical game or puzzle. It consists of three rods, and a number of disks of different sizes which can slide on

The objective of the puzzle is to move the entire stack to another rod, obeying the following rules:

On

Each move consists of taking the upper disk from on

No disk may be placed on top of a smaller disk.

The dynamic programming solution consists of solving the functional equation

- S(n,h,t) = S(n-1,h, not(h,t)) ; S(1,h,t) ; S(n-1,not(h,t),t)

where n denotes the number of disks to be moved, h denotes the home rod, t denotes the target rod, not(h,t) denotes the third rod (neither h nor t), ";" denotes concatenation, and

- S(n, h, t) := solution to a problem consisting of n disks that are to be moved from rod h to rod t.

Note that for n=1 the problem is trivial, namely S(1,h,t) = "move a disk from rod h to rod t".

The number of moves required by this solution is 2n -1. If the objective is to maximize the number of moves (without cycling) then the dynamic programming functional equation is slightly more complicated and 3n -1 moves are required.[12]

[edit] Egg dropping puzzle

A broken egg, dropped from the n-th floor ...

The following is a description of the instance of this famous puzzle involving n=2 eggs and a building with H=36 floors:[13]

- Suppose that we wish to know which windows in a 36-story building are safe to drop eggs from, and which will cause the eggs to break on landing. We make a few assumptions:

An egg that survives a fall can be used again.

A broken egg must be discarded.

The effect of a fall is the same for all eggs.

If an egg breaks when dropped, then it would break if dropped from a higher window.

If an egg survives a fall then it would survive a shorter fall.

It is not ruled out that the first-floor windows break eggs, nor is it ruled out that the 36th-floor windows do not cause an egg to break.

- If on
ly on e egg is available and we wish to be sure of obtaining the right result, the experiment can be carried out in on ly on e way. Drop the egg from the first-floor window; if it survives, drop it from the second floor window. Continue upward until it breaks. In the worst case, this method may require 36 droppings. Suppose 2 eggs are available. What is the least number of egg-droppings that is guaranteed to work in all cases?

To derive a dynamic programming functional equation for this puzzle, let the state of the dynamic programming model be a pair s = (n,k), where

- n = number of test eggs available, n = 0,1,2,3,...,N-1.
- k = number of (consecutive) floors yet to be tested, k = 0,1,2,...,H-1.

For instance, s = (2,6) indicates that 2 test eggs are available and 6 (consecutive) floors are yet to be tested. The initial state of the process is s = (N,H) where N denotes the number of test eggs available at the commencement of the experiment. The process terminates either when there are no more test eggs (n = 0) or when k = 0, whichever occurs first. If termination occurs at state s=(0,k) and k>0, then the test failed.

Now, let

- W(n,k) := minimum number of trials required to identify the value of the critical floor under the Worst Case Scenario given that the process is in state s=(n,k).

Then it can be shown that[14]

- W(n,k) = 1 + min{max(W(n-1,x-1) , W(n,k-x)): x in {1,2,...,k}} , n = 2,...,N ; k = 2,3,4,...,H

with W(n,1) = 1 for all n>0 and W(1,k) = k for all k. It is easy to solve this equation iteratively by systematically increasing the values of n and k.

An interactive on

评论这张

<#--最新日志，群博日志-->
<#--推荐日志-->
<#--引用记录-->
<#--博主推荐-->
<#--随机阅读-->
<#--首页推荐-->
<#--历史上的今天-->
<#--被推荐日志-->
<#--上一篇，下一篇-->
<#-- 热度 -->
<#-- 网易新闻广告 -->
<#--右边模块结构-->
<#--评论模块结构-->
<#--引用模块结构-->
<#--博主发起的投票-->

## 评论